# BuildRailStationWindow Struct Reference

Inheritance diagram for BuildRailStationWindow:

## Public Member Functions
| BuildRailStationWindow (const WindowDesc *desc, Window *parent, bool newstation)
virtual void | OnPaint ()
| The window must be repainted.
virtual void | UpdateWidgetSize (int widget, Dimension *size, const Dimension &padding, Dimension *fill, Dimension *resize)
| Update size and resize step of a widget in the window.
virtual void | DrawWidget (const Rect &r, int widget) const
| Draw the contents of a nested widget.
virtual void | SetStringParameters (int widget) const
| Initialize string parameters for a widget.
virtual void | OnClick (Point pt, int widget, int click_count)
| A click with the left mouse button has been made on the window.
virtual void | OnDropdownSelect (int widget, int index)
| A dropdown option associated to this window has been selected.
virtual void | OnTick ()
| Called once per (game) tick.
## Private Member Functions
void | CheckSelectedSize (const StationSpec *statspec)
| Verify whether the currently selected station size is allowed after selecting a new station class/type.
## Static Private Member Functions
static DropDownList * | BuildStationClassDropDown ()
| Build a dropdown list of available station classes.
## Private Attributes
uint | line_height
| Height of a single line in the newstation selection matrix (BRSW_NEWST_LIST widget).

## Detailed Description

Definition at line 968 of file rail_gui.cpp.

## Member Function Documentation

void BuildRailStationWindow::CheckSelectedSize | ( | const StationSpec * | statspec | ) | `[inline, private]`

Verify whether the currently selected station size is allowed after selecting a new station class/type.

If not, change the station size variables ( _settings_client.gui.station_numtracks and _settings_client.gui.station_platlength ).

Parameters:

  | statspec | Specification of the new station class/type

Definition at line 977 of file rail_gui.cpp.

References _settings_client, StationSpec::disallowed_lengths, StationSpec::disallowed_platforms, ClientSettings::gui, HasBit(), Window::LowerWidget(), Window::RaiseWidget(), GUISettings::station_dragdrop, GUISettings::station_numtracks, and GUISettings::station_platlength.

Referenced by OnClick(), and OnDropdownSelect().

virtual void BuildRailStationWindow::DrawWidget | ( | const Rect & | r,
|  | int | widget |
| ) |  |  | const`[inline, virtual]`

Draw the contents of a nested widget.

Parameters:

  | r | Rectangle occupied by the widget.
  | widget | Number of the widget to draw.

Note:
  This method may not change any state, it may only use drawing functions.

Reimplemented from Window.

Definition at line 1129 of file rail_gui.cpp.

References _cur_railtype, AXIS_X, AXIS_Y, StationSpec::callback_mask, CBID_STATION_AVAILABILITY, CBM_STATION_AVAIL, DrawStationTile(), DrawString(), FillDrawPixelInfo(), FILLRECT_CHECKER, GB(), GetCustomStationSpec(), Scrollbar::GetPosition(), GfxFillRect(), HasBit(), INVALID_ROADTYPE, INVALID_TILE, Scrollbar::IsVisible(), line_height, StationSpec::name, RailStationGUISettings::station_class, RailStationGUISettings::station_count, RailStationGUISettings::station_type, Window::vscroll, WD_MATRIX_LEFT, WD_MATRIX_RIGHT, and WD_MATRIX_TOP.

virtual void BuildRailStationWindow::OnClick | ( | Point | pt,
|  | int | widget,
|  | int | click_count |
| ) |  |  | `[inline, virtual]`

A click with the left mouse button has been made on the window.

Parameters:

  | pt | the point inside the window that has been clicked.
  | widget | the clicked widget.
  | click_count | Number of fast consecutive clicks at same position

Reimplemented from Window.

Definition at line 1184 of file rail_gui.cpp.

References _settings_client, BuildStationClassDropDown(), StationSpec::callback_mask, CBID_STATION_AVAILABILITY, CBM_STATION_AVAIL, CheckSelectedSize(), DeleteWindowById(), StationSpec::disallowed_lengths, StationSpec::disallowed_platforms, GB(), Scrollbar::GetCapacity(), GetCustomStationSpec(), Scrollbar::GetPosition(), ClientSettings::gui, HasBit(), INVALID_TILE, line_height, Window::LowerWidget(), RailStationGUISettings::newstations, RailStationGUISettings::orientation, Window::RaiseWidget(), Window::SetDirty(), Window::SetWidgetLoweredState(), ShowDropDownList(), RailStationGUISettings::station_class, RailStationGUISettings::station_count, GUISettings::station_dragdrop, GUISettings::station_numtracks, GUISettings::station_platlength, GUISettings::station_show_coverage, RailStationGUISettings::station_type, Window::ToggleWidgetLoweredState(), and Window::vscroll.

virtual void BuildRailStationWindow::OnDropdownSelect | ( | int | widget,
|  | int | index |
| ) |  |  | `[inline, virtual]`

A dropdown option associated to this window has been selected.

Parameters:

  | widget | the widget (button) that the dropdown is associated with.
  | index | the element in the dropdown that is selected.

Reimplemented from Window.

Definition at line 1340 of file rail_gui.cpp.

References CheckSelectedSize(), DeleteWindowById(), GetCustomStationSpec(), GetNumCustomStations(), Scrollbar::SetCount(), Window::SetDirty(), Scrollbar::SetPosition(), RailStationGUISettings::station_class, RailStationGUISettings::station_count, RailStationGUISettings::station_type, and Window::vscroll.

virtual void BuildRailStationWindow::OnPaint | ( |  | ) | `[inline, virtual]`

The window must be repainted.

Note:
  This method should not change any state, it should only use drawing functions.

Reimplemented from Window.

Definition at line 1050 of file rail_gui.cpp.

References _remove_button_clicked, _settings_client, _settings_game, AXIS_X, CA_TRAIN, CA_UNMODIFIED, NWidgetBase::current_x, NWidgetBase::current_y, StationSpec::disallowed_lengths, StationSpec::disallowed_platforms, DrawStationCoverageAreaText(), Window::DrawWidgets(), GetCustomStationSpec(), ClientSettings::gui, HasBit(), StationSettings::modified_catchment, RailStationGUISettings::newstations, RailStationGUISettings::orientation, NWidgetBase::pos_x, NWidgetBase::pos_y, ResizeWindow(), SCT_ALL, SetTileSelectSize(), Window::SetWidgetDisabledState(), NWidgetBase::smallest_y, GameSettings::station, RailStationGUISettings::station_class, GUISettings::station_dragdrop, GUISettings::station_numtracks, GUISettings::station_platlength, GUISettings::station_show_coverage, StationSettings::station_spread, RailStationGUISettings::station_type, Swap(), Window::top, WD_FRAMERECT_LEFT, WD_FRAMERECT_RIGHT, and WD_PAR_VSEP_NORMAL.

virtual void BuildRailStationWindow::SetStringParameters | ( | int | widget | ) | const`[inline, virtual]`

Initialize string parameters for a widget.

Calls to this function are made during initialization to measure the size (that is as part of InitNested()), during drawing, and while re-initializing the window. Only for widgets that render text initializing is requested.

Parameters:

  | widget | Widget number.

Reimplemented from Window.

Definition at line 1179 of file rail_gui.cpp.

References GetStationClassName(), SetDParam(), and RailStationGUISettings::station_class.

virtual void BuildRailStationWindow::UpdateWidgetSize | ( | int | widget,
|  | Dimension * | size,
|  | const Dimension & | padding,
|  | Dimension * | fill,
|  | Dimension * | resize |
| ) |  |  | `[inline, virtual]`

Update size and resize step of a widget in the window.

After retrieval of the minimal size and the resize-steps of a widget, this function is called to allow further refinement, typically by computing the real maximal size of the content. Afterwards, size is taken to be the minimal size of the widget and resize is taken to contain the resize steps. For the convenience of the callee, padding contains the amount of padding between the content and the edge of the widget. This should be added to the returned size.

Parameters:

  | widget | Widget number.
  | size | Size of the widget.
  | padding | Recommended amount of space between the widget content and the widget edge.
  | fill | Fill step of the widget.
  | resize | Resize step of the widget.

Reimplemented from Window.

Definition at line 1096 of file rail_gui.cpp.

References FONT_HEIGHT_NORMAL, GB(), GetCustomStationSpec(), GetNumCustomStations(), GetNumStationClasses(), GetStationClassName(), GetStringBoundingBox(), line_height, MAT_ROW_BITS, MAT_ROW_START, max(), maxdim(), StationSpec::name, SetDParam(), STAT_CLASS_BEGIN, STAT_CLASS_WAYP, WD_MATRIX_BOTTOM, and WD_MATRIX_TOP.

The documentation for this struct was generated from the following file:

- src/rail_gui.cpp